//
//
// *****************************************************
// *                GDVD - 2.15 beta                   *
// * ------------------------------------------------- *
// *                                                   *
// * Writtin by John Robicheau and Michael R. Eckhoff  *
// * 												   *
// *        With the help of GLADE Gui I.D.E.		   *
// *                                                   *
// * A frontend to 'dvdplay' by Andrew De Quincey and  *
// * Lucien Murray-Pitts.                              *
// *                                                   *
// * Note:  This software is ONLY for the Creative     *
// * Encore 5x DXR2 DVD-PC Kit.  The DXR3 is NOT 	   *
// * supported by the current driver.  Please do not   *
// * email either myself, Michael, Lucien, or Andrew   *
// * regarding the status of drivers for the Encore 6X *
// * DVD Kit,  thank you.							   *
// *												   *
// * ------------------------------------------------- *
// * 												   *
// *   Please feel free to submit bug reports to:      *
// * 												   *
// *           		havok@havoknet.com                 *
// * 	                    or 						   *
// *				  foobar@null.net                  *
// *												   *
// *****************************************************
//
//


#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>

#include <gnome.h>

#include "interface.h"
#include "support.h"
#include "widget.h"

#define maxline 4
#define ONE "1"
#define ZERO "0"

extern char inputa[2];
extern char inputb[20];
extern char play_command[100];
extern char mount_dev[10];			//This sets the default drive to /dev/hdb
extern char mount_point[15];		//This sets the default mount point to /mnt/dvd
extern char drive_stat;
extern char drive_tmp[60];
extern char vga_geom[20];
extern char *dvd_title_pre;

extern int sub_tog;

extern int mnt_d;

extern int mnt_pnt_1;
extern int mnt_pnt_2;
extern int mnt_pnt_3;
extern int mnt_typ_1;
extern int mnt_typ_2;

int css;
int ifo;
int angle;
int audio_str;
int audio_frq = 1;
int audio_bit;
int audio_wth;
int tv_type;
int video_bit;
int out_type;
int out_rat;
int mount_type;
int sub;
int sub_on;
int popup;
int p_status;
		//   The Player Status INT is to determine the current play status of GDVD
		//   Its values are indicative of:
		//
		//		0 - stopped
		//		1 - playing
		// 		2 - paused	
int d_status;
		//    The DVD Drive status INT is to determine the status of the Drive, 
		//    mounted, or not.
		//
		//	 	0 - unmounted
		//		1 - mounted
int dxr_status; 
		//     The dxr status INT is for wether or not the DXR2 driver module has been loaded.
		//
		//		0 - not loaded
		//		1 - loaded

/*--------------Options variables -------------*/

int vga;		// VGA overlay ON/OFF
int dev;
int mpoint;

char ifo_conf[maxline];
char css_conf[maxline];
char angle_conf[maxline];
char sub_on_conf[maxline];
char sub_conf[maxline];
char mnt_dev_conf[maxline];
char mnt_pnt_conf[maxline];
char mnt_type_conf[maxline];
char audio_frq_conf[maxline];
char audio_bit_conf[maxline];
char audio_wth_conf[maxline];
char audio_str_conf[maxline];
char vga_conf[maxline];
char out_type_conf[maxline];
char video_bit_conf[maxline];
char tv_type_conf[maxline];
char out_rat_conf[maxline];

FILE *config;


int
main (int argc, char *argv[])
{
  GtkWidget *gdvd;
  GtkWidget *splash;

// **************************************************
// *       ROUTINE to READ the CONFIG FILE          *
// * 												*
// *           FILE is /etc/gdvd.conf               *
// **************************************************

while ((config = fopen("/etc/gdvd.conf", "rb") == NULL))
		{
		printf("****************************************\n");
		printf("\n\nConfig file not found: Setting defaults.\n\n");
		printf("****************************************\n");
		config = fopen("/etc/gdvd.conf", "wb");
		
// **************************************************************
//   Set the default config if the gdvd.conf file is not found.
// **************************************************************

		g_snprintf(css_conf, sizeof(css_conf), "1");
		g_snprintf(ifo_conf, sizeof(ifo_conf), "1");
		g_snprintf(mnt_dev_conf, sizeof(mnt_dev_conf), "1");
		g_snprintf(mnt_pnt_conf, sizeof(mnt_pnt_conf), "1");
		g_snprintf(mnt_type_conf, sizeof(mnt_type_conf), "0");
		g_snprintf(angle_conf, sizeof(angle_conf), "0");
		g_snprintf(sub_on_conf, sizeof(sub_on_conf), "0");
		g_snprintf(sub_conf, sizeof(sub_conf), "0");
		g_snprintf(audio_frq_conf, sizeof(audio_frq_conf), "1");
		
// ***********************************
//    write the initial config file.
// ***********************************
	
		fprintf(config, "%s\n%s\n%s\n%s\n%s\n%s\n%s\n%s\n%s",css_conf,ifo_conf,sub_on_conf,sub_conf,angle_conf,mnt_dev_conf,mnt_pnt_conf,mnt_type_conf,audio_frq_conf);
		}

// *********************************************
//        READ the EXISTING gdvd.conf file
// *********************************************


config = fopen("/etc/gdvd.conf", "rb");
fscanf(config, "%s", css_conf);

	css = atoi(css_conf);

fscanf(config, "%s", ifo_conf);

	ifo = atoi(ifo_conf);
		
fscanf(config, "%s", sub_on_conf);

	sub_on = atoi(sub_on_conf);
	if (sub_on == 1)
		sub_tog = 1;
	else
		sub_tog = 0;
		
fscanf(config, "%s", sub_conf);

	sub = atoi(sub_conf);

fscanf(config, "%s", angle_conf);

	angle = atoi(angle_conf);

fscanf(config, "%s", mnt_dev_conf);

	dev = atoi(mnt_dev_conf);
	if(dev == 1)
		{
		g_snprintf(mount_dev, sizeof(mount_dev), "/dev/hdb");
		mnt_d = 1;
		
		}
	else if(dev == 2)
		{
		g_snprintf(mount_dev, sizeof(mount_dev), "/dev/hdc");
		mnt_d = 2;
		}
	else if(dev == 3)
		{
		g_snprintf(mount_dev, sizeof(mount_dev), "/dev/hdd");
		mnt_d = 3;
		}
	else if(dev == 4)
		{
		g_snprintf(mount_dev, sizeof(mount_dev), "/dev/scd0");
		mnt_d = 4;
		}
	else if(dev == 5)
		{
		g_snprintf(mount_dev, sizeof(mount_dev), "/dev/scd1");
		mnt_d = 5;
		}
	else if(dev == 6)
		{
		g_snprintf(mount_dev, sizeof(mount_dev), "/dev/scd2");
		mnt_d = 6;
		}
	else if(dev == 7)
		{
		g_snprintf(mount_dev, sizeof(mount_dev), "/dev/scd3");
		mnt_d = 7;
		}
	else if(dev == 8)
		{
		g_snprintf(mount_dev, sizeof(mount_dev), "/dev/scd4");
		mnt_d = 8;
		}
	else if(dev == 9)
		{
		g_snprintf(mount_dev, sizeof(mount_dev), "/dev/scd5");
		mnt_d = 9;
		}
	else if(dev == 10)
		{
		g_snprintf(mount_dev, sizeof(mount_dev), "/dev/scd6");
		mnt_d = 10;
		}
	else if(dev == 11)
		{
		g_snprintf(mount_dev, sizeof(mount_dev), "/dev/scd7");
		mnt_d = 11;
		}
	else if(dev == 12)
		{
		g_snprintf(mount_dev, sizeof(mount_dev), "/dev/scd8");
		mnt_d = 12;
		}
	else if(dev == 13)
		{
		g_snprintf(mount_dev, sizeof(mount_dev), "/dev/scd9");
		mnt_d = 13;
		}
		
fscanf(config, "%s", mnt_pnt_conf);	

	mpoint = atoi(mnt_pnt_conf);
	if (mpoint == 1)
		{
		g_snprintf(mount_point, sizeof(mount_point), "/mnt/dvd");

		mnt_pnt_1 = 1;
		mnt_pnt_2 = 0;
		mnt_pnt_3 = 0;
		
		}
	else if (mpoint == 2)
		{
		g_snprintf(mount_point, sizeof(mount_point), "/dvd");

		mnt_pnt_1 = 0;
		mnt_pnt_2 = 1;
		mnt_pnt_3 = 0;
		}
	else if (mpoint == 3)
		{
		g_snprintf(mount_point, sizeof(mount_point), "/video/dvd");

		mnt_pnt_1 = 0;
		mnt_pnt_2 = 0;
		mnt_pnt_3 = 1;
		}

fscanf(config, "%s", mnt_type_conf);

	mount_type = atoi(mnt_type_conf);
	if (mount_type == 0)
		{
		mnt_typ_1 = 1;
		mnt_typ_2 = 0;
		}
	else if (mount_type == 1)
		{
		mnt_typ_1 = 0;
		mnt_typ_2 = 1;
		}


fscanf(config, "%s", audio_frq_conf);

	audio_frq = atoi(audio_frq_conf);

fscanf(config, "%s", audio_bit_conf);

	audio_bit = atoi(audio_bit_conf);

fscanf(config, "%s", audio_wth_conf);

	audio_wth = atoi(audio_wth_conf);

fscanf(config, "%s", audio_str_conf);

	audio_str = atoi(audio_str_conf);

fscanf(config, "%s", vga_conf);

	vga = atoi(vga_conf);

fscanf(config, "%s", out_type_conf);

	out_type = atoi(out_type_conf);	

fscanf(config, "%s", video_bit_conf);

	video_bit = atoi(video_bit_conf);

fscanf(config, "%s", tv_type_conf);

	tv_type = atoi(tv_type_conf);

fscanf(config, "%s", out_rat_conf);

	out_rat = atoi(out_rat_conf);		

printf("css: %s\n",css_conf);
printf("ifo: %s\n",ifo_conf);
printf("Sub on/off: %s\n",sub_on_conf);
printf("sub: %s\n",sub_conf);
printf("angle: %s\n",angle_conf);
printf("CSS INT: %d  ",css);	
printf("IFO INT: %d  ",ifo);
printf("Sub ON INT: %d\n",sub_on);
printf("SUB INT: %d  ",sub);
printf("ANGLE INT: %d  ",angle);
printf("Device: %d\n",dev);
printf("Audio Freq: %d\n", audio_frq);
fclose(config);

  gtk_set_locale ();
  gtk_init (&argc, &argv);
  add_pixmap_directory (PACKAGE_DATA_DIR "/pixmaps");
  add_pixmap_directory (PACKAGE_SOURCE_DIR "/pixmaps");


	splash = create_splash ();
	gtk_widget_show (splash);


  /*
   * The following code was added by Glade to create one of each component
   * (except popup menus), just so that you see something after building
   * the project. Delete any components that you don't want shown initially.
   */
  gdvd = create_gdvd ();
  gtk_widget_show (gdvd);

  gtk_main ();


  return 0;

  
}








