/***************************************************************************
                          extensions.cpp  -  description
                             -------------------
    begin                : Thu Jan 27 2000
    copyright            : (C) 2000 by Jeff Anderson
    email                : jbanders@mines.edu
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "mpeg2enc.h"
#include "buffer.h"
#include "extensions.h"

extern OBUFF outbuff;

/************************************************************************/
/************************************************************************/
PICTURE_CODING_EXT::PICTURE_CODING_EXT(void)
{
	f_code[0][0] = 15;
	f_code[0][1] = 15;
	f_code[1][0] = 15;
	f_code[1][1] = 15;
 	
	intra_dc_precision = 0;
	picture_structure = 3;
	top_field_first = 0;
  frame_pred_frame_dct = 1;
  concealment_motion_vectors = 0;
  q_scale_type = 1;
  intra_vlc_format = 0;
  alternate_scan = 0;
  repeat_first_field = 0;
  chroma_420_type = 1;
  progressive_frame = 1;
  composite_display_flag = 0;
  v_axis = 0;
  sub_carrier = 0;
  burst_amplitude = 0;
  sub_carrier_phase = 0;
}
/************************************************************************/
void PICTURE_CODING_EXT::write(void)
{
	outbuff.byte_allign();

	outbuff.put_bits(1,24);	//start code
	outbuff.put_bits(extension_start_code,8);
	outbuff.put_bits(extension_start_code_identifier,4); //4-bit

	outbuff.put_bits(f_code[0][0], 4);																		//4-bit x 4
	outbuff.put_bits(f_code[0][1], 4);
	outbuff.put_bits(f_code[1][0], 4);
	outbuff.put_bits(f_code[1][1], 4);

	outbuff.put_bits(intra_dc_precision, 2);																	// 2-bit
	outbuff.put_bits(picture_structure, 2);																		// 2-bit
	outbuff.put_bits(top_field_first, 1);																			//1-bit
	outbuff.put_bits(frame_pred_frame_dct, 1);																//1-bit
	outbuff.put_bits(concealment_motion_vectors, 1);													//1-bit
	outbuff.put_bits(q_scale_type, 1);																				//1-bit
	outbuff.put_bits(intra_vlc_format, 1);																		//1-bit
	outbuff.put_bits(alternate_scan, 1);																			//1-bit
	outbuff.put_bits(repeat_first_field, 1);																	//1-bit
	outbuff.put_bits(chroma_420_type, 1);																			//1-bit
	outbuff.put_bits(progressive_frame, 1);																		//1-bit
	outbuff.put_bits(composite_display_flag, 1);															//1-bit
	if(composite_display_flag)
	{
		outbuff.put_bits(v_axis, 1);																							//1-bit
		outbuff.put_bits(field_sequence, 1);																			//3-bit
		outbuff.put_bits(sub_carrier, 1);																					//1-bit
		outbuff.put_bits(burst_amplitude, 1);																			//7-bit
		outbuff.put_bits(sub_carrier_phase, 1);																		// 8-bit
	} //end if
} //end write()
/************************************************************************/
/************************************************************************/
SEQUENCE_EXTENSION::SEQUENCE_EXTENSION()
{
	profile_and_level_indication = 72; //8-bit
	progressive_sequence = 1; //1-bit
	chroma_format = 1; //2-bit
	horizontal_size_extension = 0; //2-bit
	vertical_size_extension = 0; //2-bit
	bit_rate_extension = 0; //12-bit

	vbv_buffer_size_extension = 0; //8-bit
	low_delay = 1; //1-bit
	frame_rate_extension_n = 0; //2-bit
	frame_rate_extension_d = 0; //5-bit
}	
/************************************************************************/	
void SEQUENCE_EXTENSION::write(void)
{
	outbuff.byte_allign();

	outbuff.put_bits(1,24);	//start code
	outbuff.put_bits(extension_start_code,8);
	outbuff.put_bits(extension_start_code_identifier,4); //4-bit
	outbuff.put_bits(profile_and_level_indication,8); //8-bit
	outbuff.put_bits(progressive_sequence,1); //1-bit
	outbuff.put_bits(chroma_format,2); //2-bit
	outbuff.put_bits(horizontal_size_extension,2); //2-bit
	outbuff.put_bits(vertical_size_extension,2); //2-bit
	outbuff.put_bits(bit_rate_extension,12); //12-bit
	outbuff.put_bits(marker_bit,1); //1-bit
	outbuff.put_bits(vbv_buffer_size_extension,8); //8-bit
	outbuff.put_bits(low_delay,1); //1-bit
	outbuff.put_bits(frame_rate_extension_n,2); //2-bit
	outbuff.put_bits(frame_rate_extension_d,5); //5-bit
}
/************************************************************************/
/************************************************************************/