/***************************************************************************
                          mpeg2enc.cpp  -  description
                             -------------------
    begin                : Tue Dec 7 1999
    copyright            : (C) 1999 by Jeff Anderson
    email                : jbanders@mines.edu
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef MPEG2ENC_H
# define MPEG2END_H
#include "mpeg2enc.h"
#endif

#ifndef OBJECTS_H
# define OBJECTS_H
#include "objects.h"
#endif

#ifndef STATS_H
# define STATS_H
#include "stats.h"
#endif

#ifndef BUFFER_H
#define BUFFER_H
#include "buffer.h"
#endif

#include <string>

IBUFF input;
STATS mpstat;
OBUFF outbuff;

void mpeg2enc(int argc, char** argv)
{
	parse_args(argc, argv);

	SEQUENCE seq;

} // end mpeg2enc	

void parse_args(int argc, char **argv)
{

	if(argc < 2)
	{
		print_usage();
		exit(1);
	}

	for(int i = 1; i < argc; i++)
	{
		if( (strcmp(argv[i] ,"--help")) == 0 )
		{
			print_usage();
			exit(0);
		}
		if( (strcmp(argv[i] ,"-hz")) == 0 )
			mpstat.set_horizontal_size(atoi(argv[i+1]));
		if( (strcmp(argv[i] ,"-vz")) == 0 )
			mpstat.set_vertical_size(atoi(argv[i+1]));
		if( (strcmp(argv[i] ,"-f")) == 0 )
			input.set_file_pattern(argv[i+1]);
		if( (strcmp(argv[i] ,"-fr")) == 0 )
			mpstat.set_frame_rate(argv[i+1]);
	}


} //end parse_args

void print_usage(void)
{
	cout << "Usage: mpeg2enc [OPTIONS]" << endl;

	cout << "\t-f,\t\tYUV frame input" << endl;
	cout << "\t-hz,\t\tHorizontal Size" << endl;
	cout << "\t-vz,\t\tVertical Size" << endl;
	cout << "\t-fr,\t\tFrame Rate...24,25,30,50,60 default=24" << endl;

}


































