// this is code which vill vanish once the new plugin system has been
// established

/*
 *
 * Copyright (C) 2000  Thomas Mirlacher
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * The author may be reached as dent@cosy.sbg.ac.at, or
 * Thomas Mirlacher, Jakob-Haringerstr. 2, A-5020 Salzburg,
 * Austria
 *
 *------------------------------------------------------------
 *
 */


#ifndef __CODEC_H__
#define __CODEC_H__

#include <oms/plugin/codec_audio.h>
#include <oms/plugin/codec_video.h>
#include <oms/plugin/codec_spu.h>


//********** once fully moved to the new stuff ... delete below

#include <sys/types.h>
#include <oms/plugin/id.h>

typedef struct plugin_codec_struct {
// private stuff
	void *priv;
// init codec
	int (*init)		(struct plugin_codec_struct *plugin, buf_t *buf, char *output_path);
// exit codec
	int (*exit)		(struct plugin_codec_struct *plugin);
// open codec
	int (*open)		(struct plugin_codec_struct *plugin);
// close codec
	int (*close)		(struct plugin_codec_struct *plugin);

// read codec
        int (*read)		(struct plugin_codec_struct *plugin, buf_t *buf, buf_entry_t *buf_entry);
// write codec
        int (*write)		(struct plugin_codec_struct *plugin, buf_t *buf, buf_entry_t *buf_entry);

// set operational status (PLAY, PAUSE, STOP, ...)
	int (*set_status)	(struct plugin_codec_struct *plugin, u_int stats);
// set attributes (audio, video, spu)
	int (*set_attributes)	(struct plugin_codec_struct *plugin, u_int id, void *attr);
} plugin_codec_t;

#endif
