
/*
 *
 * Copyright (C) 1999  Thomas Mirlacher
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * The author may be reached as dent@cosy.sbg.ac.at, or
 * Thomas Mirlacher, Jakob-Haringerstr. 2, A-5020 Salzburg,
 * Austria
 *
 *------------------------------------------------------------
 *
 */


#ifndef __INPUT_H__
#define __INPUT_H__

#include <sys/types.h>
#include <oms/plugin/id.h>

/**
 * input struct
 **/ 

typedef struct {
// open 
	int (*open)		(char *name);
// close 
	int (*close)		();
// get next block of data
	int (*read)		(char *data, u_int len);
// seek in put stream
	int (*seek)		(u_long pos);
// blocksize
	u_int blocksize;
// a private data structure
	void *priv;
} plugin_input_t;
#endif
