#ifndef __SPU_H__
#define __SPU_H__

struct spu_img_struct {
	u_char *data;		// 7-4: mixer key, 3-0: color index
	u_int x;		// x start of subpicture area
	u_int y;		// y start of subpicture area
	int width;		// width of subpicture area
	int height;		// height of subpicture area

	u_char clut[4];		// color lookup table
	u_char trans[4];	// mixer key table

	u_int time_execute;	// time in ms

// private stuff
	u_int	_x;		// current destination x, y
	u_int	_y;
	u_int	offset[2];	// address in PXD to fetch next rle-code from, one per field
};


// DENT: change RGB value of CLUT int YUV value (and use yuv2rgb)
static u_int spu_clut[16] = 
{
	0x00505050,
	0x00ff0000,
	0xffffffff,
	0x00000000,
	0x00005555,
	0x0000ff00,
	0x00cc2255,
	0x00cc0055,
	0x00404040,
	0x00202020,
	0x00b0b0b0,
	0x00d0d0d0,
	0x60606000,
	0x70707000,
	0x80808000,
	0x60606000,
};

void spuInit (void);
void decode_spu(u_char *data_start, u_char *data_end);
u_int buffer_spupack(u_int *length, u_char **start, u_char *end);
void spuSetCLUT (u_char *clut);
int spuParseHdr (struct spu_img_struct *spu, u_char *pkt_data, u_int pkt_len);
void spuParseData (struct spu_img_struct *spu);

#endif
