//DENT: compile warnings occur when processing this file, caused
//	by wrong command lines ... but this file will be the test aerea
//	for the new plugin system ... so just ignore the warnings
//	this plugin works - only the new functions do raise these warnings  

#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>
#include <stdlib.h>
#include <string.h>
#include <sys/ioctl.h>

#ifndef NULL
#define NULL 0L
#endif

#include <oms/oms.h>
#include <oms/buf.h>
#include <oms/plugin.h>

#include "dxr2-api.h"

static int _dxr2_init (plugin_codec_t *plugin, buf_t *buf, char *output_path);
static int _dxr2_open (plugin_codec_t *plugin);
static int _dxr2_close (u_int id, u_int type);
static int _dxr2_read (plugin_codec_t *plugin, buf_t *buf, buf_entry_t *buf_entry);
static int _dxr2_set_stat (plugin_codec_t *plugin, u_int status);
static int _dxr2_set_attr (plugin_codec_t *plugin, u_int id, void *attr);

static struct dxr2_priv_struct {
	char *path;
	int fd_dxr2;
	int current_audio_mode;
	int current_audio_stream;
	buf_t *buf;
	int status;

	dxr2_status_info_t dxr2_info;
} dxr2_priv;

static int _dxr2_install_firmware (struct dxr2_priv_struct *priv, char *ucode);
static void _dxr2_init_info (dxr2_status_info_t* dxr2_info);
static int _dxr2_set_attr_audio (plugin_codec_t *plugin, plugin_codec_attr_audio_t *attr);
static int _dxr2_set_attr_video (plugin_codec_t *plugin, plugin_codec_attr_video_t *attr);
static int _dxr2_set_attr_spu (plugin_codec_t *plugin, plugin_codec_attr_spu_t *spu);

static plugin_codec_t codec_dxr2 = {
	&dxr2_priv,
	_dxr2_init,	// init
	NULL,		// exit
        _dxr2_open,	// open
        NULL,		// close
	_dxr2_read,	// read
	NULL,		// write
	_dxr2_set_stat,	// set_stat
	_dxr2_set_attr,	// set_attr
};


/****************** tests for future plugin system *******************/
static struct {
        pthread_t loop;
        pthread_cond_t playing;
        pthread_mutex_t mutex;
        int end_loop;
        char *path;
        int fd_dxr2;
        int current_audio_mode;
        int current_audio_stream;
        buf_t *buf;
        int status;

        dxr2_status_info_t dxr2_info;
} dxr2_codec;

static plugin_codec_audio_t dxr2_codec_audio = {
        _dxr2_open,
        _dxr2_close,
        NULL,           //_dxr2_read,
        NULL,           //_dxr2_write,
        _dxr2_set_stat,
        _dxr2_set_attr_audio
};

static plugin_codec_video_t dxr2_codec_video = {
        _dxr2_open,
        _dxr2_close,
        NULL,           //_dxr2_read,
        NULL,           //_dxr2_write,
        _dxr2_set_stat,
        _dxr2_set_attr_video
};
/****************** tests for future plugin system *******************/

/**
 *
 */

static int _dxr2_init (plugin_codec_t *plugin, buf_t *buf, char *output_path)
{
	struct dxr2_priv_struct *priv = plugin->priv;
	char whoami[] = "__FILE__";
	priv->buf = buf;
	priv->path = output_path;

	priv->current_audio_mode = -1;
	priv->current_audio_stream = -1;

_dxr2_open (plugin);

	return 0;
}


/**
 *
 */

static int _dxr2_open (plugin_codec_t *plugin)
{
	struct dxr2_priv_struct *priv = plugin->priv;
	dxr2_status_info_t *dxr2_info = &priv->dxr2_info;

  // open device
	if ((priv->fd_dxr2 = open (priv->path, O_WRONLY)) < 0) {
		perror(priv->path);
		return -1;
	}  

	dxr2_init (priv->fd_dxr2);

	if (_dxr2_install_firmware (priv, "/etc/dvd12.ux") == -1)
		return -1;

	_dxr2_init_info (dxr2_info);

	dxr2_set_params (dxr2_info);

	dxr2_set_overlay_crop (dxr2_info->overlay_crop.arg1,
		dxr2_info->overlay_crop.arg2,
		dxr2_info->overlay_crop.arg3,
		dxr2_info->overlay_crop.arg4);
	dxr2_set_overlay_size (dxr2_info->overlay_dim.arg1,
		dxr2_info->overlay_dim.arg2);
	dxr2_set_overlay_position (dxr2_info->overlay_pos.arg1,
		dxr2_info->overlay_pos.arg2);
	dxr2_set_overlay_mode (dxr2_info->overlay_mode.arg);

	priv->status = DXR2_PLAYMODE_STOPPED;

	return 0;
}


/**
 *
 **/

static int _dxr2_close (u_int id, u_int type)
{
	fprintf (stderr, "DXR@ close\n");
}


/**
 *
 **/

static int _dxr2_read (plugin_codec_t *plugin, buf_t *buf, buf_entry_t *buf_entry)
{
	struct dxr2_priv_struct *priv = plugin->priv;
	u_int size = buf_entry->mem_len;

	while (size)
		size -= write (priv->fd_dxr2, buf_entry->mem, size);

	return 0;
}


/**
 *
 **/

static int _dxr2_install_firmware (struct dxr2_priv_struct *priv, char *ucode)
{
	int uCodeFD;
	int uCodeSize;
	dxr2_uCode_t* uCode;

	if ((uCodeFD = open (ucode, O_RDONLY)) < 0) {
		perror (ucode);
		return -1;
	}
	uCodeSize = lseek (uCodeFD, 0, SEEK_END);
	if ((uCode = (dxr2_uCode_t*) malloc (uCodeSize + 4)) == NULL) {
		perror ("malloc");
		return -1;
	}
	lseek(uCodeFD, 0, SEEK_SET);
	if (read (uCodeFD, uCode+4, uCodeSize) != uCodeSize) {
		perror (ucode);
		return -1;
	}
	close (uCodeFD);
	uCode->uCodeLength = uCodeSize;

	// upload ucode
	if (dxr2_install_firmware (priv->fd_dxr2, uCode)) {
		fprintf (stderr,"uCode upload failed!\n");
		return -1;
	}

	free (uCode);

	return 0;
}


/**
 *
 **/

static int _dxr2_set_attr_video (plugin_codec_t *plugin, plugin_codec_attr_video_t *attr)
{
	struct dxr2_priv_struct *priv = plugin->priv;
	// Change of fps can't be done while playing
	if (priv->status == DXR2_PLAYMODE_PLAY && attr->fps != -1)
		dxr2_set_playmode (DXR2_PLAYMODE_STOPPED);


	if (attr->mode != -1) {
		int type;

		switch (attr->mode) {
		case 0:
			type = DXR2_BITSTREAM_TYPE_MPEG_VOB;
			break;
		case 1:
			type = DXR2_BITSTREAM_TYPE_CDROM_VCD;
			break;
		case 2:
			type = DXR2_BITSTREAM_TYPE_CDDA;
			break;
		default:
			return -1;		
		}

		if (dxr2_set_video_type (type))
			return -1;
	}

	if (attr->fps != -1) {
		int freq;

		switch (attr->fps) {
		case 0:
			freq = DXR2_SRC_VIDEO_FREQ_30;
			break;
		case 1:
			freq = DXR2_SRC_VIDEO_FREQ_25;
			break;
		default:
			return -1;
		}

		if (dxr2_set_video_freq (freq))
			return -1;
	}

	if (attr->aspect_mode != -1) {
		int mode;

		switch (attr->aspect_mode) {
		case 0:
			mode = DXR2_ASPECTRATIOMODE_NORMAL;
			break;
		case 1:
			mode = DXR2_ASPECTRATIOMODE_PAN_SCAN;
			break;
		case 2:
			mode = DXR2_ASPECTRATIOMODE_LETTERBOX;
			break;
		default:
			return -1;
		}

		if (dxr2_set_scaling_mode (mode))
			return -1;
	}    

	if (attr->aspect_output != -1) {
		int ratio;

		switch (attr->aspect_output) {
		case 0:
			ratio = DXR2_ASPECTRATIO_4_3;
			break;
		case 3:
			ratio = DXR2_ASPECTRATIO_16_9;
			break;
		default:
			return -1;
		}

		if (dxr2_set_source_ratio (ratio))
			return -1;
	}

	if (attr->tv_system != -1) {
		int format;

		switch (attr->tv_system) {
		case 0:
			format = DXR2_OUTPUTFORMAT_NTSC;
			break;				
		case 1:
			format = DXR2_OUTPUTFORMAT_NTSC_60;
			break;
		case 2:
			format = DXR2_OUTPUTFORMAT_PAL_BDGHI;
			break;
		case 3:
			format = DXR2_OUTPUTFORMAT_PAL_M;
			break;
		case 4:
			format = DXR2_OUTPUTFORMAT_PAL_M_60;
			break;
		case 5:
			format = DXR2_OUTPUTFORMAT_PAL_N;
			break;
		case 6:
			format = DXR2_OUTPUTFORMAT_PAL_Nc;
			break;
		case 7:
			format = DXR2_OUTPUTFORMAT_PAL_60;
			break;
		default:
			return -1;
		}

		if (dxr2_set_tv_format (format))
			return -1;
	}

	if (priv->status == DXR2_PLAYMODE_PLAY && attr->fps != -1)
		dxr2_set_playmode (DXR2_PLAYMODE_PLAY);

	return 0;
}


/**
 *
 */

static int _dxr2_set_attr_audio (plugin_codec_t *plugin, plugin_codec_attr_audio_t *attr)
{
	struct dxr2_priv_struct *priv = plugin->priv;

	if (!attr)
		return -1;

	if (attr->volume != -1) {
		int volume;

		if (attr->volume > 100 || attr->volume < 0)
			return -1;

		volume = attr->volume*19/100;

		if (dxr2_set_volume (volume))
			return -1;
	}

	if (attr->freq != -1) {
		int freq;

		switch (attr->freq) {
		case 0:	
			freq = DXR2_AUDIO_FREQ_441;
			break;
		case 1:
			freq = DXR2_AUDIO_FREQ_48;
			break;
		case 2:
			freq = DXR2_AUDIO_FREQ_96;
			break;
		case 3:
			freq = DXR2_AUDIO_FREQ_2205;
			break;
		case 4:
			freq = DXR2_AUDIO_FREQ_32;
			break;
		default:
			return -1;
		}
		
		if (dxr2_set_audio_freq (freq))
			return -1;
	}

	if (attr->bits != -1) {
		int width = 0;

		switch (attr->bits) {
		case 0:
			width = DXR2_AUDIO_WIDTH_16;
			break;
		case 1:
			width = DXR2_AUDIO_WIDTH_20;
			break;
		case 2:
			width = DXR2_AUDIO_WIDTH_24;
			break;
		default:
			return -1;
		}

		if (dxr2_set_audio_width (width))
			return -1;
	}

	if (attr->mode != -1) {
		switch (attr->mode) {
		case 0:
			priv->current_audio_mode = DXR2_STREAM_AUDIO_AC3;
			break;
		case 1:
			priv->current_audio_mode = DXR2_STREAM_AUDIO_MPEG;
			break;
		case 2:
			priv->current_audio_mode = DXR2_STREAM_AUDIO_LPCM;
			break;
		default:
			return -1;
		}
	}

	if (attr->stream != -1)
		priv->current_audio_stream = attr->stream;

	if (attr->stream != -1 || attr->mode != -1) {
		int type;
		int stream;

		if (priv->current_audio_mode==-1)
			return -1;

		type = priv->current_audio_mode;
		stream = priv->current_audio_stream;

		if (dxr2_select_audio (type, stream))
			return -1;
	}

	return 0;
}


/**
 *
 **/

static int _dxr2_set_attr_spu (plugin_codec_t *plugin, plugin_codec_attr_spu_t *spu)
{
	struct dxr2_priv_struct *priv = plugin->priv;

	if (spu->num == -1) {
		return dxr2_subpicture (DXR2_SUBPICTURE_OFF);
	} else {
		if (dxr2_subpicture (DXR2_SUBPICTURE_ON))
			return -1;

		dxr2_select_subpicture (spu->num);
	}

	if (spu->clut) {
		char clut[64];
		int i;

		for (i=0; i<16; i++) {
			clut[i*4+0] = spu->clut[i*4+3];
			clut[i*4+1] = spu->clut[i*4+2];
			clut[i*4+2] = spu->clut[i*4+1];
			clut[i*4+3] = spu->clut[i*4+0];
		}

		return ioctl (priv->fd_dxr2, DXR2_IOC_SET_SUBPICTURE_PALETTE, clut);
	}

	return 0;
}


/**
 *
 **/

static int _dxr2_set_attr (plugin_codec_t *plugin, u_int id, void *attr)
{
	switch (id) {
	case BUF_AUDIO: 
		if (_dxr2_set_attr_audio (plugin, (plugin_codec_attr_audio_t *) attr))
			return -1;
		break;
	case BUF_VIDEO:
		if (_dxr2_set_attr_video (plugin, (plugin_codec_attr_video_t *) attr))
			return -1;
		break;
	case BUF_SUBPIC:
		if (_dxr2_set_attr_spu (plugin, (plugin_codec_attr_spu_t *) attr))
			return -1;
		break;
	}

	return 0;
}


/**
 *
 **/

static int _dxr2_set_stat (plugin_codec_t *plugin, u_int status)
{
	struct dxr2_priv_struct *priv = plugin->priv;

	switch (status) {
	case STATUS_PLAY:
		dxr2_set_playmode (DXR2_PLAYMODE_PLAY);
		priv->status = DXR2_PLAYMODE_PLAY;
		break;
	case STATUS_STOP:
		if (dxr2_set_playmode (DXR2_PLAYMODE_STOPPED))
			return -1;
		return ioctl(priv->fd_dxr2,DXR2_IOC_CLEAR_VIDEO,NULL);
		break;
	}

	return 0;
}


/**
 * shamelessly copied from dxr2/config.c
 * (c) Andrew Veliath, Andrew de Quincey, Lucien Murray-Pitts
 **/

static void _dxr2_init_info (dxr2_status_info_t* dxr2_info)
{
  // Default values
	//dxr2_info->tv_format.arg=DXR2_OUTPUTFORMAT_NTSC;
	dxr2_info->tv_format.arg=DXR2_OUTPUTFORMAT_PAL_M;
  // Set this to an invalid value so that we set it later based on tv_format
	dxr2_info->video_freq.arg1=-1;
	dxr2_info->video_freq.arg2=0x2d0;
	dxr2_info->video_freq.arg3=0x1e0;
	dxr2_info->output_aspect_ratio.arg=DXR2_ASPECTRATIO_4_3;
	dxr2_info->bitstream_type.arg=DXR2_BITSTREAM_TYPE_MPEG_VOB;
	dxr2_info->macro_vision.arg=DXR2_MACROVISION_OFF;
	dxr2_info->pixel_mode.arg=DXR2_PIXEL_CCIR601;
//	dxr2_info->interlaced_mode.arg=DXR2_INTERLACED_ON;
	dxr2_info->interlaced_mode.arg=DXR2_INTERLACED_OFF;
	dxr2_info->x75ire_mode.arg=DXR2_75IRE_OFF;
	dxr2_info->volume.arg=50;
	dxr2_info->mute.arg=DXR2_AUDIO_MUTE_OFF;
	dxr2_info->audio_width.arg=DXR2_AUDIO_WIDTH_16;
	dxr2_info->audio_freq.arg=DXR2_AUDIO_FREQ_441;
	dxr2_info->iec_output_mode.arg=DXR2_IEC958_ENCODED;
//	dxr2_info->subpicture.arg=DXR2_SUBPICTURE_OFF;
	dxr2_info->subpicture_stream_id.arg1=DXR2_STREAM_SUBPICTURE;
	dxr2_info->subpicture_stream_id.arg2=0;
	dxr2_info->audio_stream.arg1=DXR2_STREAM_AUDIO_AC3;
	dxr2_info->audio_stream.arg2=0;
	dxr2_info->video_stream.arg1=DXR2_STREAM_VIDEO;
	dxr2_info->video_stream.arg2=0;

  /* VGA OVERLAY INFO */
#if 0
	dxr2_info->overlay_crop.arg1 = 0; // left
	dxr2_info->overlay_crop.arg2 = 0; // right
	dxr2_info->overlay_crop.arg3 = 20; // top
	dxr2_info->overlay_crop.arg4 = 20;  // bottom
#else
	dxr2_info->overlay_crop.arg1 = 0; // left
	dxr2_info->overlay_crop.arg2 = 0; // right
	dxr2_info->overlay_crop.arg3 = 55; // top
//	dxr2_info->overlay_crop.arg3 = 0; // top
	dxr2_info->overlay_crop.arg4 = 355;  // bottom
//	dxr2_info->overlay_crop.arg4 = 0;  // bottom
#endif
	dxr2_info->overlay_pos.arg1 = 100; // origin X
	dxr2_info->overlay_pos.arg2 = 25; // origin Y
#if 0
	dxr2_info->overlay_dim.arg1 = 800; // size horiz
	dxr2_info->overlay_dim.arg2 = 600; // size vert
#else
	dxr2_info->overlay_dim.arg1 = 640; // size horiz
	dxr2_info->overlay_dim.arg2 = 480; // size vert
#endif
//	dxr2_info->overlay_mode.arg = DXR2_OVERLAY_DISABLED;
	dxr2_info->overlay_mode.arg = DXR2_OVERLAY_WINDOW_KEY;
	dxr2_info->gain.arg1 = 63; // common gain (0-63)
	dxr2_info->gain.arg2 = 8; // red-gain (0-15)
	dxr2_info->gain.arg3 = 10; // green-gain (0-15)
	dxr2_info->gain.arg4 = 10; // blue-gain (0-15)
	dxr2_info->picture.arg1 = 48; // gamma
	dxr2_info->picture.arg2 = 127; // contrast
	dxr2_info->picture.arg3 = 127; // brightness
	dxr2_info->picture.arg4 = -128; // saturation
}


/*********************************************************************/
/**
 *
 */

#if 0
int DecoderHighlightButton(plugin_codec_t *plugin, int button)
{
	dxr2_threeArg_t buf3;
	buf3.arg1 = button;
	buf3.arg2 = DXR2_BUTTONACTION_ACTIVATE_SELECTED;
	return ioctl(priv->fd_dxr2,DXR2_IOC_HIGHLIGHT,&buf3); 
}

#endif


/**
 * Initialize Plugin.
 **/

void *plugin_init (char *whoami)
{
	// if (!dxr2_present)
	// 	return -1;

	pluginRegister (whoami,
		PLUGIN_ID_CODEC_AUDIO | PLUGIN_ID_CODEC_AUDIO_ALL,
		STREAM_ID_MPEG2,
		&dxr2_codec_audio);
	pluginRegister (whoami,
		PLUGIN_ID_OUTPUT_AUDIO,
		0,
		&dxr2_codec_audio);	// &dxr2_output_audio);
	pluginRegister (whoami,
		PLUGIN_ID_CODEC_VIDEO | PLUGIN_ID_CODEC_VIDEO_ALL,
		STREAM_ID_MPEG2,
		&dxr2_codec_video);
	pluginRegister (whoami,
		PLUGIN_ID_OUTPUT_VIDEO,
		0,
		&dxr2_codec_video);	// &dxr2_output_video);
	pluginRegister (whoami,
		PLUGIN_ID_CODEC_SPU | PLUGIN_ID_CODEC_SPU_ALL,
		STREAM_ID_MPEG2,
		&dxr2_codec_video);
/*
	pluginRegister (whoami,
		PLUGIN_ID_DESCRAMBLE | PLUGIN_ID_DESCRAMBLE_CSS,
		STREAM_ID_MPEG2,
		&dxr2_descramble);
*/

	return &codec_dxr2;
}


/**
 * Cleanup Plugin.
 **/

void plugin_exit (void)
{
}
