/* -*- linux-c -*- --------------------------------------------------------- *  
 * This is file is part of the ZORAN zr367x0 driver
 *
 * Copyright (C) 1999 David Barth <dbarth@besancon.net>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */

#ifndef _MGADVD_H
#define _MGADVD_H

#include <linux/videodev.h>

#define I34_NTSC	01
#define I34_NTSC_ALT	02
#define I34_PAL		03
#define I34_PAL_ALT	04

#define BITSTREAM_DVD_VOB	0x1000
#define BITSTREAM_MPEG_SYSTEM	0x3800
#define BITSTREAM_MPEG_ES	0x6000
#define BITSTREAM_MPEG_PES	0x6800
#define BITSTREAM_MPEG_AUDIO	0x7800
#define BITSTREAM_AC3_AUDIO	0xB000
#define BITSTREAM_LPCM_AUDIO	0xC000

struct mgadvd_status_s
{
	unsigned int status0;
	unsigned int status1;
	unsigned int status2;
	unsigned int sclk;
	unsigned int video_buffer_status;
	unsigned int audio_buffer_status;
	unsigned char adp_status_reply[16];
};

/* the IOCTL number depends on videodev2.h, but I get parse error when including it
   from inside this header...
*/
#define BASE_VIDIOC_PRIVATE 192	/* this comes from videodev2.h */

#define I34_IOCTRESET		_IO   ('V', BASE_VIDIOC_PRIVATE)
#define I34_IOCTSTART		_IO   ('V', BASE_VIDIOC_PRIVATE +  1)
#define I34_IOCTSTOP		_IO   ('V', BASE_VIDIOC_PRIVATE +  2)
#define I34_IOCTPAUSE		_IO   ('V', BASE_VIDIOC_PRIVATE +  3)
#define I34_IOCTCONT		_IO   ('V', BASE_VIDIOC_PRIVATE +  4)
#define I34_IOCGSTATE		_IOR  ('V', BASE_VIDIOC_PRIVATE +  5, int)
#define I34_IOCGSTATUS		_IOR  ('V', BASE_VIDIOC_PRIVATE +  6, struct mgadvd_status_s)
#define I34_IOCSVIDEOSID	_IOW  ('V', BASE_VIDIOC_PRIVATE +  7, int)
#define I34_IOCSAUDIOSID	_IOW  ('V', BASE_VIDIOC_PRIVATE +  8, int)
#define I34_IOCSSTREAMTYPE	_IOW  ('V', BASE_VIDIOC_PRIVATE +  9, int)

#ifdef CSS_SUPPORT
#define I34_IOCS_DISK_KEY	_IOW  ('V', BASE_VIDIOC_PRIVATE + 32, dvd_authinfo)
#define I34_IOCS_TITLE_KEY	_IOW  ('V', BASE_VIDIOC_PRIVATE + 33, dvd_authinfo)
#define I34_IOCG_CHAL_KEY	_IOR  ('V', BASE_VIDIOC_PRIVATE + 34, dvd_authinfo)
#define I34_IOCS_CHAL_KEY	_IOW  ('V', BASE_VIDIOC_PRIVATE + 35, dvd_authinfo)
#define I34_IOCG_RESP_KEY	_IOR  ('V', BASE_VIDIOC_PRIVATE + 36, dvd_authinfo)
#define I34_IOCS_RESP_KEY	_IOW  ('V', BASE_VIDIOC_PRIVATE + 37, dvd_authinfo)
#endif



#endif /* _MGADVD_H */
