/*  XMMS - Cross-platform multimedia player
 *  Copyright (C) 1998-1999  Peter Alm, Mikael Alm, Olle Hallnas, Thomas Nilsson and 4Front Technologies
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

/*
 * Modified 03/12/99 by Guenter Bartsch for use in oms
 * Modified 09/01/00 by Guenter Bartsch for freeform user-defined skins
 */

#ifndef PBUTTON_H
#define PBUTTON_H

#include "gtk/gtk.h"
#include "widget.h"



typedef struct
{
    Widget     mWidget;
    GdkPixmap *mpSkin;
    gboolean   mbPressed, mbInside, mbAllowDraw;
    gboolean   mbPrelight, mbHasStatus;
    void     (*mPushCb) (int nID, GdkEventButton *pEvent);
    gint       mnId ;
    gboolean   mbStatus;
    gboolean   mbImmediate;
} PButton;

PButton *create_pbutton(GList ** wlist, GdkPixmap * parent, 
			GdkGC * gc, 
			gint x, gint y, gint w, gint h,
			GdkPixmap *pSkin,
			gboolean bPrelight,
			gboolean bHasStatus,
			void (*cb) (int nID, GdkEventButton *pEvent), 
			gint nID);

void change_pbutton(PButton *b, 
		    GdkPixmap *parent,
		    gint x, gint y, gint w, gint h,
		    GdkPixmap *pSkin,
		    gboolean   bPrelight,
		    gboolean   bHasStatus,
		    gint nID);

void free_pbutton(PButton * b);

void pbutton_set_status (PButton *b, gboolean bStatus);

void pbutton_set_immediate (PButton *b, gboolean bImmediate);

#endif
